package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMRFODE;
import cn.ibizlab.eam.core.eam_core.filter.EMRFODESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMRFODE] 服务对象接口
 */
public interface IEMRFODEService extends IService<EMRFODE>{

    boolean checkKey(EMRFODE et) ;
    boolean save(EMRFODE et) ;
    void saveBatch(List<EMRFODE> list) ;
    boolean update(EMRFODE et) ;
    void updateBatch(List<EMRFODE> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(EMRFODE et) ;
    void createBatch(List<EMRFODE> list) ;
    EMRFODE get(String key) ;
    EMRFODE getDraft(EMRFODE et) ;
    Page<EMRFODE> searchDefault(EMRFODESearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMRFODE> getEmrfodeByIds(List<String> ids) ;
    List<EMRFODE> getEmrfodeByEntities(List<EMRFODE> entities) ;

}


